Package com.oracle.truffle.object.basic

## Class BasicLocations.SimpleObjectFieldLocation

- java.lang.Object
- - com.oracle.truffle.api.object.Location
  - - com.oracle.truffle.object.LocationImpl
    - - com.oracle.truffle.object.basic.BasicLocations.FieldLocation
      - - com.oracle.truffle.object.basic.BasicLocations.SimpleObjectFieldLocation

All Implemented Interfaces:
  `BaseLocation`, `ObjectLocation`, `TypedLocation`

Enclosing class:
  BasicLocations

    public abstract static class BasicLocations.SimpleObjectFieldLocation
    extends BasicLocations.FieldLocation
    implements ObjectLocation

### Nested Class Summary

### Nested classes/interfaces inherited from class com.oracle.truffle.object.LocationImpl

`LocationImpl.EffectivelyFinalLocation<T extends Location>, LocationImpl.InternalLongLocation, LocationImpl.TypedObjectLocation<T extends Location & ObjectLocation>`

### Constructor Summary

Constructors
`SimpleObjectFieldLocation​(int index)`

### Method Summary

All Methods Instance Methods Abstract Methods Concrete Methods
`boolean` `canStore​(java.lang.Object value)` Returns `true` if the location is compatible with the value.
`abstract java.lang.Object` `get​(DynamicObject store, boolean condition)` Get object value as object at this location in store.
`java.lang.Class<? extends java.lang.Object>` `getType()` The type of this location.
`boolean` `isNonNull()` If `true`, this location does not accept `null` values.
`int` `objectFieldCount()` Get the number of in-object `Object` fields this location requires.
`abstract void` `setInternal​(DynamicObject store, java.lang.Object value)` Like `Location.set(DynamicObject, Object, Shape)`, but does not invalidate final locations.

### Methods inherited from class com.oracle.truffle.object.basic.BasicLocations.FieldLocation

`equals, getIndex, getWhereString, hashCode`

### Methods inherited from class com.oracle.truffle.object.LocationImpl

`canSet, canStoreFinal, getInternal, isConstant, isFinal, objectArrayCount, primitiveArrayCount, primitiveFieldCount, set, toString, valueEquals`

### Methods inherited from class com.oracle.truffle.api.object.Location

`checkShape, finalLocation, get, incompatibleLocation, set, set`

### Methods inherited from class java.lang.Object

`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

### Methods inherited from interface com.oracle.truffle.api.object.BaseLocation

`get, set, set, set`

### Constructor Detail

#### SimpleObjectFieldLocation

    public SimpleObjectFieldLocation​(int index)

### Method Detail

#### get

    public abstract java.lang.Object get​(DynamicObject store,
                                         boolean condition)

Description copied from interface: `BaseLocation`
Get object value as object at this location in store. For internal use only and subject to change, use `BaseLocation.get(DynamicObject, Shape)` instead.

Specified by:
  `get` in interface `BaseLocation`
Overrides:
  `get` in class `Location`
  `condition` - the result of a shape check or `false`
See Also:
  `BaseLocation.get(DynamicObject, Shape)`

#### setInternal

    public abstract void setInternal​(DynamicObject store,
                                     java.lang.Object value)

Description copied from class: `Location`
Like `Location.set(DynamicObject, Object, Shape)`, but does not invalidate final locations. For internal use only and subject to change, use `DynamicObjectFactory` to create objects with predefined properties.

Specified by:
  `setInternal` in class `LocationImpl`

#### canStore

    public boolean canStore​(java.lang.Object value)

Description copied from class: `Location`
Returns `true` if the location is compatible with the value. The value may still be rejected if `Location.canSet(DynamicObject, Object)` returns false.

Overrides:
  `canStore` in class `LocationImpl`
Parameters:
  `value` - the value in question

#### getType

    public java.lang.Class<? extends java.lang.Object> getType()

Description copied from interface: `TypedLocation`
The type of this location.

Specified by:
  `getType` in interface `ObjectLocation`
Specified by:
  `getType` in interface `TypedLocation`

#### isNonNull

    public boolean isNonNull()

Description copied from interface: `ObjectLocation`
If `true`, this location does not accept `null` values.

Specified by:
  `isNonNull` in interface `ObjectLocation`

#### objectFieldCount

    public int objectFieldCount()

Description copied from class: `LocationImpl`
Get the number of in-object `Object` fields this location requires.

Overrides:
  `objectFieldCount` in class `LocationImpl`